//+------------------------------------------------------------------+
//|                                         adaptivemacd 4 color mtf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    7
#property indicator_color1     LimeGreen
#property indicator_color2     LimeGreen
#property indicator_color3     Orange
#property indicator_color4     Orange
#property indicator_color5     DimGray
#property indicator_color6     PaleVioletRed
#property indicator_color7     PaleVioletRed
#property indicator_style7     STYLE_DOT
#property indicator_width1     2
#property indicator_width3     2
#property indicator_width5     2
#property indicator_width6     2
#property indicator_level1     0

//
//
//
//
//

enum enPrices
{
   pr_close,   // Close
   pr_open,    // Open
   pr_high,    // High
   pr_low,     // Low
   pr_median,  // Median
   pr_typical, // Typical
   pr_weighted // Weighted
};
enum enMaTypes
{
   ma_sma,     // sma (simple moving average)
   ma_ema,     // ema (exponential moving average)
   ma_smma,    // smma (smoothed moving average)
   ma_lwma     // lwma (liner weighted moving average)
};


extern string    TimeFrame       = "Current time frame";
extern int       FastMa          = 12;
extern enMaTypes FastMaMode      = ma_ema;
extern enPrices  FastMaPrice     = pr_close;
extern int       AmaPeriod       = 26;
extern enPrices  AmaPrice        = pr_close;
extern int       Nfast           = 5;
extern int       Nslow           = 20;
extern double    GCoeff          = 2.0;
extern int       SignalMa        = 9;
extern enMaTypes SignalMaMode    = ma_ema;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double osma[];
double green_buffer[];
double green_bufferd[];
double red_buffer[];
double red_bufferu[];
double macd[];
double sig[];
double kAMAbuffer[];
double diff[];
double trend[];
double slope[];

//
//
//
//
//

double fastend;
double slowend;
string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
 IndicatorBuffers(11);
   SetIndexBuffer(0,green_buffer);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,green_bufferd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,red_buffer);    SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,red_bufferu);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,osma);
   SetIndexBuffer(5,macd);
   SetIndexBuffer(6,sig);
   SetIndexBuffer(7,kAMAbuffer);
   SetIndexBuffer(8,diff);
   SetIndexBuffer(9,trend);
   SetIndexBuffer(10,slope);
   
      fastend   = (2.0 /(Nfast + 1));
      slowend   = (2.0 /(Nslow + 1));
   //
   //
   //
   //
   //
      
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  adaptive macd ("+FastMa+","+AmaPeriod+")");
   return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {
   
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { green_buffer[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,(int)AmaPrice,i);

         if (i > Bars-AmaPeriod) { kAMAbuffer[i] = price; continue; }
   
         double efratio = 1.00;
         double noise   = 0.00;
         double smooth;
         double signal;
             signal  = MathAbs(price-iMA(NULL,0,1,0,MODE_SMA,(int)AmaPrice,i+AmaPeriod));
             diff[i] = MathAbs(price-iMA(NULL,0,1,0,MODE_SMA,(int)AmaPrice,i+1));
                for (int k=0;k<AmaPeriod;k++)
                        noise += diff[i+k];
                        if (noise != 0) efratio = signal/noise;
                            smooth        = MathPow(efratio*(fastend-slowend)+slowend,GCoeff);
                            kAMAbuffer[i] = kAMAbuffer[i+1] + smooth*(price-kAMAbuffer[i+1]);
                            macd[i]       = iMA(NULL,0,FastMa,0,(int)FastMaMode,(int)FastMaPrice,i) - kAMAbuffer[i];
      }
      for (i=limit; i>=0; i--)
      {
         sig[i]           = iMAOnArray(macd,Bars,SignalMa,0,(int)SignalMaMode,i);
         osma[i]          = macd[i]- sig[i];
         green_buffer[i]  = EMPTY_VALUE;
         green_bufferd[i] = EMPTY_VALUE;
         red_buffer[i]    = EMPTY_VALUE;
         red_bufferu[i]   = EMPTY_VALUE;
         slope[i]         = slope[i+1];        
         trend[i]         = trend[i+1]; 
            if (osma[i]>osma[i+1]) slope[i] =  1;
            if (osma[i]<osma[i+1]) slope[i] = -1;
	         if (macd[i] > sig[i])  trend[i] =  1; 
	         if (macd[i] < sig[i])  trend[i] = -1;
            if(osma[i] > 0) 
               if (slope[i] == 1)
                     green_buffer[i]  = osma[i];
               else  green_bufferd[i] = osma[i];
            else 
               if (slope[i] == -1)
                     red_buffer[i]  = osma[i]; 
               else  red_bufferu[i] = osma[i]; 
      }
      manageAlerts();
      return(0);
   }
  
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         osma[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,FastMaPrice,AmaPeriod,AmaPrice,Nfast,Nslow,GCoeff,SignalMa,SignalMaMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         macd[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,FastMaPrice,AmaPeriod,AmaPrice,Nfast,Nslow,GCoeff,SignalMa,SignalMaMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y);
         sig[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,FastMaPrice,AmaPeriod,AmaPrice,Nfast,Nslow,GCoeff,SignalMa,SignalMaMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,6,y);
         slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,FastMaPrice,AmaPeriod,AmaPrice,Nfast,Nslow,GCoeff,SignalMa,SignalMaMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,10,y);
         green_buffer[i]  = EMPTY_VALUE;
         green_bufferd[i] = EMPTY_VALUE;
         red_buffer[i]    = EMPTY_VALUE;
         red_bufferu[i]   = EMPTY_VALUE;

         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         for(int x = 1; x < n; x++)
         {
  	         osma[i+x] = osma[i] + (osma[i+n] - osma[i]) * x/n;
  	         macd[i+x] = macd[i] + (macd[i+n] - macd[i]) * x/n;
  	         sig[i+x]  = sig[i]  + (sig[i+n]  - sig[i])  * x/n;
         }  	            
   }
   for (i=limit; i>=0; i--)
   {
      if(osma[i] > 0) 
         if (slope[i] == 1)
               green_buffer[i]  = osma[i];
         else  green_bufferd[i] = osma[i];
      else 
         if (slope[i] == -1)
               red_buffer[i]  = osma[i]; 
         else  red_bufferu[i] = osma[i]; 
   }
   return(0);
}
      
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," adaptive macd changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," adaptive macd "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}